Page MenuHomeVyOS Platform

Zabbix Proxy crash on actual version of VyOS
Closed, ResolvedPublic

Description

Hello all!
I after some changes of VyOS got strange issue with Zabbix Proxy, i opened bug report on Zabbix: https://support.zabbix.com/browse/ZBX-15544
Could some one look throw it? May be you know what was changed in VyOS that got this issue?

Details

Difficulty level
Unknown (require assessment)
Version
1.2.0
Why the issue appeared?
Will be filled on close

Event Timeline

hexes triaged this task as Normal priority.Feb 1 2019, 12:40 AM
hexes created this task.
hexes created this object in space S1 VyOS Public.
hexes added a comment.Feb 9 2019, 2:47 PM

no ideas?

hagbard closed this task as Invalid.Feb 9 2019, 7:12 PM
hagbard claimed this task.
hagbard added a subscriber: hagbard.

looks to me like a classic buffer overflow on the zabix agent.

*3454:20190130:011020.193 received configuration data from server at "10.255.0.1", datalen 3123*

*3478:20190130:011036.282 Got signal [signal:11(SIGSEGV),reason:1,refaddr:0xffffffffff600000]. Crashing ...*
*3478:20190130:011036.283 ====== Fatal information: ======*
*3478:20190130:011036.283 Program counter: 0xffffffffff600000*
hexes added a comment.Feb 10 2019, 4:36 PM

nonono,

I have removed resolving of IP address into DNS, you can also try compiling with --enable-ipv6 flag to use different functions in order to avoid this issue.
Can you please provide a little bit more information about you system ? It is very strange that gethostbyaddr() function crash, have you tried updating your system to latest version ?

after removing of this, everything is fine!.. So it's not a buffer overflow...

Nope. The function gethostbyaddr() is a libc function. What you can do is to try to reproduce the issue under debian 8 (jessie).
The crash in the zabbix ticket however is that the zabbix proxy is crashing when it received 3123 byte from 10.255.0.1.

received configuration data from server at "10.255.0.1", datalen 3123*
hexes added a comment.Feb 12 2019, 3:27 PM

for example it crashing when in config from server there is a discovery rule with network like 192.168.1.0/24, early, before we patched it and remove gethostbyaddr conversion, it crashes when agent connects to it...
So it's look like all depend from ip addresses and may be gethostbyaddr....

hexes added a comment.Feb 13 2019, 3:20 PM

Vladislav thinks that the bug is not in Zabbix. On the one hand, I agree with him, because early (on early version of VyOS 1.2 at summer, autumn) it works perfectly...
But test app that he made for me works ok, without crashes... So i dont know what to do... Any ideas?

hexes reopened this task as Open.Feb 13 2019, 3:23 PM
hexes added subscribers: dmbaturin, syncer.

Daniil, Yuriy, plz watch on it, may be you got any ideas?

hagbard removed hagbard as the assignee of this task.Feb 13 2019, 4:13 PM
pasik added a subscriber: pasik.Feb 14 2019, 6:49 PM
hexes closed this task as Resolved.Jun 16 2019, 3:33 PM
hexes claimed this task.

When I compiled it without --static everything went well.